# coding: utf-8

"""
AuditApi.py
Copyright 2016 SmartBear Software

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class AuditApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def create_audit_topic(self, audit_topic, **kwargs):
        """
        
        Create a new audit topic.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_audit_topic(audit_topic, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param AuditTopicCreateParams audit_topic:  (required)
        :return: CreateResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['audit_topic']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_audit_topic" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'audit_topic' is set
        if ('audit_topic' not in params) or (params['audit_topic'] is None):
            raise ValueError("Missing the required parameter `audit_topic` when calling `create_audit_topic`")


        resource_path = '/platform/1/audit/topics'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'audit_topic' in params:
            body_params = params['audit_topic']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='CreateResponse',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def delete_audit_topic(self, audit_topic_id, **kwargs):
        """
        
        Delete the audit topic.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_audit_topic(audit_topic_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str audit_topic_id: Delete the audit topic. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['audit_topic_id']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_audit_topic" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'audit_topic_id' is set
        if ('audit_topic_id' not in params) or (params['audit_topic_id'] is None):
            raise ValueError("Missing the required parameter `audit_topic_id` when calling `delete_audit_topic`")


        resource_path = '/platform/1/audit/topics/{AuditTopicId}'.replace('{format}', 'json')
        path_params = {}
        if 'audit_topic_id' in params:
            path_params['AuditTopicId'] = params['audit_topic_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def get_audit_progress(self, **kwargs):
        """
        
        View current audit log time.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_audit_progress(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int lnn: lnn of the node.
        :return: AuditProgress
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['lnn']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_audit_progress" % key
                )
            params[key] = val
        del params['kwargs']



        resource_path = '/platform/4/audit/progress'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'lnn' in params:
            query_params['lnn'] = params['lnn']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='AuditProgress',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def get_audit_settings(self, **kwargs):
        """
        
        View per-Access Zone Audit settings.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_audit_settings(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str zone: Access zone which contains audit settings.
        :return: AuditSettings
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['zone']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_audit_settings" % key
                )
            params[key] = val
        del params['kwargs']



        resource_path = '/platform/3/audit/settings'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'zone' in params:
            query_params['zone'] = params['zone']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='AuditSettings',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def get_audit_topic(self, audit_topic_id, **kwargs):
        """
        
        Retrieve the audit topic information.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_audit_topic(audit_topic_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str audit_topic_id: Retrieve the audit topic information. (required)
        :return: AuditTopics
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['audit_topic_id']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_audit_topic" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'audit_topic_id' is set
        if ('audit_topic_id' not in params) or (params['audit_topic_id'] is None):
            raise ValueError("Missing the required parameter `audit_topic_id` when calling `get_audit_topic`")


        resource_path = '/platform/1/audit/topics/{AuditTopicId}'.replace('{format}', 'json')
        path_params = {}
        if 'audit_topic_id' in params:
            path_params['AuditTopicId'] = params['audit_topic_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='AuditTopics',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def get_progress_global(self, **kwargs):
        """
        
        View the global audit log time.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_progress_global(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :return: ProgressGlobal
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_progress_global" % key
                )
            params[key] = val
        del params['kwargs']



        resource_path = '/platform/4/audit/progress/global'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ProgressGlobal',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def get_settings_global(self, **kwargs):
        """
        
        View Global Audit settings.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_settings_global(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :return: SettingsGlobalExtended
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_settings_global" % key
                )
            params[key] = val
        del params['kwargs']



        resource_path = '/platform/3/audit/settings/global'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='SettingsGlobalExtended',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def list_audit_topics(self, **kwargs):
        """
        
        Retrieve a list of audit topics.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_audit_topics(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :return: AuditTopicsExtended
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_audit_topics" % key
                )
            params[key] = val
        del params['kwargs']



        resource_path = '/platform/1/audit/topics'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='AuditTopicsExtended',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def update_audit_settings(self, audit_settings, **kwargs):
        """
        
        Modify per-Access Zone Audit settings.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.update_audit_settings(audit_settings, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param AuditSettingsSettings audit_settings:  (required)
        :param str zone: Access zone which contains audit settings.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['audit_settings', 'zone']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_audit_settings" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'audit_settings' is set
        if ('audit_settings' not in params) or (params['audit_settings'] is None):
            raise ValueError("Missing the required parameter `audit_settings` when calling `update_audit_settings`")


        resource_path = '/platform/3/audit/settings'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'zone' in params:
            query_params['zone'] = params['zone']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'audit_settings' in params:
            body_params = params['audit_settings']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def update_audit_topic(self, audit_topic, audit_topic_id, **kwargs):
        """
        
        Modify the audit topic.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.update_audit_topic(audit_topic, audit_topic_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param AuditTopic audit_topic:  (required)
        :param str audit_topic_id: Modify the audit topic. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['audit_topic', 'audit_topic_id']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_audit_topic" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'audit_topic' is set
        if ('audit_topic' not in params) or (params['audit_topic'] is None):
            raise ValueError("Missing the required parameter `audit_topic` when calling `update_audit_topic`")
        # verify the required parameter 'audit_topic_id' is set
        if ('audit_topic_id' not in params) or (params['audit_topic_id'] is None):
            raise ValueError("Missing the required parameter `audit_topic_id` when calling `update_audit_topic`")


        resource_path = '/platform/1/audit/topics/{AuditTopicId}'.replace('{format}', 'json')
        path_params = {}
        if 'audit_topic_id' in params:
            path_params['AuditTopicId'] = params['audit_topic_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'audit_topic' in params:
            body_params = params['audit_topic']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def update_settings_global(self, settings_global, **kwargs):
        """
        
        Modify Global Audit settings.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.update_settings_global(settings_global, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param SettingsGlobalSettings settings_global:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['settings_global']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_settings_global" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'settings_global' is set
        if ('settings_global' not in params) or (params['settings_global'] is None):
            raise ValueError("Missing the required parameter `settings_global` when calling `update_settings_global`")


        resource_path = '/platform/3/audit/settings/global'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'settings_global' in params:
            body_params = params['settings_global']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response
