# coding: utf-8

"""
ProtocolsHdfsApi.py
Copyright 2016 SmartBear Software

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class ProtocolsHdfsApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def create_proxyusers_name_member(self, proxyusers_name_member, name, **kwargs):
        """
        
        Add a member to the HDFS proxyuser.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_proxyusers_name_member(proxyusers_name_member, name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param AuthAccessAccessItemFileGroup proxyusers_name_member:  (required)
        :param str name:  (required)
        :return: CreateResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['proxyusers_name_member', 'name']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_proxyusers_name_member" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'proxyusers_name_member' is set
        if ('proxyusers_name_member' not in params) or (params['proxyusers_name_member'] is None):
            raise ValueError("Missing the required parameter `proxyusers_name_member` when calling `create_proxyusers_name_member`")
        # verify the required parameter 'name' is set
        if ('name' not in params) or (params['name'] is None):
            raise ValueError("Missing the required parameter `name` when calling `create_proxyusers_name_member`")


        resource_path = '/platform/1/protocols/hdfs/proxyusers/{Name}/members'.replace('{format}', 'json')
        path_params = {}
        if 'name' in params:
            path_params['Name'] = params['name']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'proxyusers_name_member' in params:
            body_params = params['proxyusers_name_member']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='CreateResponse',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def delete_proxyusers_name_member(self, proxyusers_name_member_id, name, **kwargs):
        """
        
        Remove a member from the HDFS proxyuser.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_proxyusers_name_member(proxyusers_name_member_id, name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str proxyusers_name_member_id: Remove a member from the HDFS proxyuser. (required)
        :param str name:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['proxyusers_name_member_id', 'name']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_proxyusers_name_member" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'proxyusers_name_member_id' is set
        if ('proxyusers_name_member_id' not in params) or (params['proxyusers_name_member_id'] is None):
            raise ValueError("Missing the required parameter `proxyusers_name_member_id` when calling `delete_proxyusers_name_member`")
        # verify the required parameter 'name' is set
        if ('name' not in params) or (params['name'] is None):
            raise ValueError("Missing the required parameter `name` when calling `delete_proxyusers_name_member`")


        resource_path = '/platform/1/protocols/hdfs/proxyusers/{Name}/members/{ProxyusersNameMemberId}'.replace('{format}', 'json')
        path_params = {}
        if 'proxyusers_name_member_id' in params:
            path_params['ProxyusersNameMemberId'] = params['proxyusers_name_member_id']
        if 'name' in params:
            path_params['Name'] = params['name']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def list_proxyusers_name_members(self, name, **kwargs):
        """
        
        List all the members of the HDFS proxyuser.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_proxyusers_name_members(name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str name:  (required)
        :return: GroupMembers
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['name']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_proxyusers_name_members" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'name' is set
        if ('name' not in params) or (params['name'] is None):
            raise ValueError("Missing the required parameter `name` when calling `list_proxyusers_name_members`")


        resource_path = '/platform/1/protocols/hdfs/proxyusers/{Name}/members'.replace('{format}', 'json')
        path_params = {}
        if 'name' in params:
            path_params['Name'] = params['name']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='GroupMembers',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def update_proxyusers_name_member(self, proxyusers_name_member, proxyusers_name_member_id, name, **kwargs):
        """
        
        Create a new HDFS proxyuser.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.update_proxyusers_name_member(proxyusers_name_member, proxyusers_name_member_id, name, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Empty proxyusers_name_member:  (required)
        :param str proxyusers_name_member_id: Create a new HDFS proxyuser. (required)
        :param str name:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['proxyusers_name_member', 'proxyusers_name_member_id', 'name']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_proxyusers_name_member" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'proxyusers_name_member' is set
        if ('proxyusers_name_member' not in params) or (params['proxyusers_name_member'] is None):
            raise ValueError("Missing the required parameter `proxyusers_name_member` when calling `update_proxyusers_name_member`")
        # verify the required parameter 'proxyusers_name_member_id' is set
        if ('proxyusers_name_member_id' not in params) or (params['proxyusers_name_member_id'] is None):
            raise ValueError("Missing the required parameter `proxyusers_name_member_id` when calling `update_proxyusers_name_member`")
        # verify the required parameter 'name' is set
        if ('name' not in params) or (params['name'] is None):
            raise ValueError("Missing the required parameter `name` when calling `update_proxyusers_name_member`")


        resource_path = '/platform/1/protocols/hdfs/proxyusers/{Name}/members/{ProxyusersNameMemberId}'.replace('{format}', 'json')
        path_params = {}
        if 'proxyusers_name_member_id' in params:
            path_params['ProxyusersNameMemberId'] = params['proxyusers_name_member_id']
        if 'name' in params:
            path_params['Name'] = params['name']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'proxyusers_name_member' in params:
            body_params = params['proxyusers_name_member']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response
