# coding: utf-8

"""
QuotaQuotasApi.py
Copyright 2016 SmartBear Software

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class QuotaQuotasApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def create_quota_notification(self, quota_notification, qid, **kwargs):
        """
        
        Create a new notification rule specific to this quota.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_quota_notification(quota_notification, qid, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param QuotaNotificationCreateParams quota_notification:  (required)
        :param str qid:  (required)
        :return: CreateResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['quota_notification', 'qid']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_quota_notification" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'quota_notification' is set
        if ('quota_notification' not in params) or (params['quota_notification'] is None):
            raise ValueError("Missing the required parameter `quota_notification` when calling `create_quota_notification`")
        # verify the required parameter 'qid' is set
        if ('qid' not in params) or (params['qid'] is None):
            raise ValueError("Missing the required parameter `qid` when calling `create_quota_notification`")


        resource_path = '/platform/1/quota/quotas/{Qid}/notifications'.replace('{format}', 'json')
        path_params = {}
        if 'qid' in params:
            path_params['Qid'] = params['qid']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'quota_notification' in params:
            body_params = params['quota_notification']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='CreateResponse',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def delete_quota_notification(self, quota_notification_id, qid, **kwargs):
        """
        
        Delete the notification rule.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_quota_notification(quota_notification_id, qid, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str quota_notification_id: Delete the notification rule. (required)
        :param str qid:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['quota_notification_id', 'qid']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_quota_notification" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'quota_notification_id' is set
        if ('quota_notification_id' not in params) or (params['quota_notification_id'] is None):
            raise ValueError("Missing the required parameter `quota_notification_id` when calling `delete_quota_notification`")
        # verify the required parameter 'qid' is set
        if ('qid' not in params) or (params['qid'] is None):
            raise ValueError("Missing the required parameter `qid` when calling `delete_quota_notification`")


        resource_path = '/platform/1/quota/quotas/{Qid}/notifications/{QuotaNotificationId}'.replace('{format}', 'json')
        path_params = {}
        if 'quota_notification_id' in params:
            path_params['QuotaNotificationId'] = params['quota_notification_id']
        if 'qid' in params:
            path_params['Qid'] = params['qid']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def delete_quota_notifications(self, qid, **kwargs):
        """
        
        Delete all quota specific rules. The quota will then use the global rules.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_quota_notifications(qid, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str qid:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['qid']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_quota_notifications" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'qid' is set
        if ('qid' not in params) or (params['qid'] is None):
            raise ValueError("Missing the required parameter `qid` when calling `delete_quota_notifications`")


        resource_path = '/platform/1/quota/quotas/{Qid}/notifications'.replace('{format}', 'json')
        path_params = {}
        if 'qid' in params:
            path_params['Qid'] = params['qid']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def get_quota_notification(self, quota_notification_id, qid, **kwargs):
        """
        
        Retrieve notification rule information.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_quota_notification(quota_notification_id, qid, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str quota_notification_id: Retrieve notification rule information. (required)
        :param str qid:  (required)
        :return: QuotaNotifications
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['quota_notification_id', 'qid']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_quota_notification" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'quota_notification_id' is set
        if ('quota_notification_id' not in params) or (params['quota_notification_id'] is None):
            raise ValueError("Missing the required parameter `quota_notification_id` when calling `get_quota_notification`")
        # verify the required parameter 'qid' is set
        if ('qid' not in params) or (params['qid'] is None):
            raise ValueError("Missing the required parameter `qid` when calling `get_quota_notification`")


        resource_path = '/platform/1/quota/quotas/{Qid}/notifications/{QuotaNotificationId}'.replace('{format}', 'json')
        path_params = {}
        if 'quota_notification_id' in params:
            path_params['QuotaNotificationId'] = params['quota_notification_id']
        if 'qid' in params:
            path_params['Qid'] = params['qid']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='QuotaNotifications',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def list_quota_notifications(self, qid, **kwargs):
        """
        
        List all rules.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_quota_notifications(qid, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str qid:  (required)
        :return: QuotaNotificationsExtended
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['qid']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_quota_notifications" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'qid' is set
        if ('qid' not in params) or (params['qid'] is None):
            raise ValueError("Missing the required parameter `qid` when calling `list_quota_notifications`")


        resource_path = '/platform/1/quota/quotas/{Qid}/notifications'.replace('{format}', 'json')
        path_params = {}
        if 'qid' in params:
            path_params['Qid'] = params['qid']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='QuotaNotificationsExtended',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def update_quota_notification(self, quota_notification, quota_notification_id, qid, **kwargs):
        """
        
        Modify notification rule. All input fields are optional, but one or more must be supplied.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.update_quota_notification(quota_notification, quota_notification_id, qid, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param QuotaNotification quota_notification:  (required)
        :param str quota_notification_id: Modify notification rule. All input fields are optional, but one or more must be supplied. (required)
        :param str qid:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['quota_notification', 'quota_notification_id', 'qid']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_quota_notification" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'quota_notification' is set
        if ('quota_notification' not in params) or (params['quota_notification'] is None):
            raise ValueError("Missing the required parameter `quota_notification` when calling `update_quota_notification`")
        # verify the required parameter 'quota_notification_id' is set
        if ('quota_notification_id' not in params) or (params['quota_notification_id'] is None):
            raise ValueError("Missing the required parameter `quota_notification_id` when calling `update_quota_notification`")
        # verify the required parameter 'qid' is set
        if ('qid' not in params) or (params['qid'] is None):
            raise ValueError("Missing the required parameter `qid` when calling `update_quota_notification`")


        resource_path = '/platform/1/quota/quotas/{Qid}/notifications/{QuotaNotificationId}'.replace('{format}', 'json')
        path_params = {}
        if 'quota_notification_id' in params:
            path_params['QuotaNotificationId'] = params['quota_notification_id']
        if 'qid' in params:
            path_params['Qid'] = params['qid']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'quota_notification' in params:
            body_params = params['quota_notification']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response

    def update_quota_notifications(self, quota_notifications, qid, **kwargs):
        """
        
        This method creates an empty set of rules so that the global rules are not used. The input must be an empty JSON object.

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.update_quota_notifications(quota_notifications, qid, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param Empty quota_notifications:  (required)
        :param str qid:  (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['quota_notifications', 'qid']
        all_params.append('callback')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_quota_notifications" % key
                )
            params[key] = val
        del params['kwargs']

        # verify the required parameter 'quota_notifications' is set
        if ('quota_notifications' not in params) or (params['quota_notifications'] is None):
            raise ValueError("Missing the required parameter `quota_notifications` when calling `update_quota_notifications`")
        # verify the required parameter 'qid' is set
        if ('qid' not in params) or (params['qid'] is None):
            raise ValueError("Missing the required parameter `qid` when calling `update_quota_notifications`")


        resource_path = '/platform/1/quota/quotas/{Qid}/notifications'.replace('{format}', 'json')
        path_params = {}
        if 'qid' in params:
            path_params['Qid'] = params['qid']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'quota_notifications' in params:
            body_params = params['quota_notifications']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['basic_auth']

        response = self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'))
        return response
