# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class AuthAccessAccessItemFile(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AuthAccessAccessItemFile - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'effective_path': 'str',
            'file_permissions': 'AuthAccessAccessItemFileFilePermissions',
            'group': 'AuthAccessAccessItemFileGroup',
            'is_snapshot': 'bool',
            'owner': 'AuthAccessAccessItemFileGroup'
        }

        self.attribute_map = {
            'effective_path': 'effective_path',
            'file_permissions': 'file_permissions',
            'group': 'group',
            'is_snapshot': 'is_snapshot',
            'owner': 'owner'
        }

        self._effective_path = None
        self._file_permissions = None
        self._group = None
        self._is_snapshot = None
        self._owner = None

    @property
    def effective_path(self):
        """
        Gets the effective_path of this AuthAccessAccessItemFile.
        Specifies absolute path in filesystem.

        :return: The effective_path of this AuthAccessAccessItemFile.
        :rtype: str
        """
        return self._effective_path

    @effective_path.setter
    def effective_path(self, effective_path):
        """
        Sets the effective_path of this AuthAccessAccessItemFile.
        Specifies absolute path in filesystem.

        :param effective_path: The effective_path of this AuthAccessAccessItemFile.
        :type: str
        """
        
        self._effective_path = effective_path

    @property
    def file_permissions(self):
        """
        Gets the file_permissions of this AuthAccessAccessItemFile.
        Specifies a list of the relevant share permissions for the user.

        :return: The file_permissions of this AuthAccessAccessItemFile.
        :rtype: AuthAccessAccessItemFileFilePermissions
        """
        return self._file_permissions

    @file_permissions.setter
    def file_permissions(self, file_permissions):
        """
        Sets the file_permissions of this AuthAccessAccessItemFile.
        Specifies a list of the relevant share permissions for the user.

        :param file_permissions: The file_permissions of this AuthAccessAccessItemFile.
        :type: AuthAccessAccessItemFileFilePermissions
        """
        
        self._file_permissions = file_permissions

    @property
    def group(self):
        """
        Gets the group of this AuthAccessAccessItemFile.
        Specifies the persona of the file group.

        :return: The group of this AuthAccessAccessItemFile.
        :rtype: AuthAccessAccessItemFileGroup
        """
        return self._group

    @group.setter
    def group(self, group):
        """
        Sets the group of this AuthAccessAccessItemFile.
        Specifies the persona of the file group.

        :param group: The group of this AuthAccessAccessItemFile.
        :type: AuthAccessAccessItemFileGroup
        """
        
        self._group = group

    @property
    def is_snapshot(self):
        """
        Gets the is_snapshot of this AuthAccessAccessItemFile.
        Specifies whether path is inside snapshot.

        :return: The is_snapshot of this AuthAccessAccessItemFile.
        :rtype: bool
        """
        return self._is_snapshot

    @is_snapshot.setter
    def is_snapshot(self, is_snapshot):
        """
        Sets the is_snapshot of this AuthAccessAccessItemFile.
        Specifies whether path is inside snapshot.

        :param is_snapshot: The is_snapshot of this AuthAccessAccessItemFile.
        :type: bool
        """
        
        self._is_snapshot = is_snapshot

    @property
    def owner(self):
        """
        Gets the owner of this AuthAccessAccessItemFile.
        Specifies the persona of the file owner.

        :return: The owner of this AuthAccessAccessItemFile.
        :rtype: AuthAccessAccessItemFileGroup
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """
        Sets the owner of this AuthAccessAccessItemFile.
        Specifies the persona of the file owner.

        :param owner: The owner of this AuthAccessAccessItemFile.
        :type: AuthAccessAccessItemFileGroup
        """
        
        self._owner = owner

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

