# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class AuthAccessAccessItemShareSharePermissions(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AuthAccessAccessItemShareSharePermissions - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'expected_permissions': 'str',
            'impersonate_guest': 'bool',
            'impersonate_user': 'bool',
            'run_as_root': 'bool',
            'share_relevant_aces': 'list[AuthAccessAccessItemShareSharePermissionsShareRelevantAce]'
        }

        self.attribute_map = {
            'expected_permissions': 'expected_permissions',
            'impersonate_guest': 'impersonate_guest',
            'impersonate_user': 'impersonate_user',
            'run_as_root': 'run_as_root',
            'share_relevant_aces': 'share_relevant_aces'
        }

        self._expected_permissions = None
        self._impersonate_guest = None
        self._impersonate_user = None
        self._run_as_root = None
        self._share_relevant_aces = None

    @property
    def expected_permissions(self):
        """
        Gets the expected_permissions of this AuthAccessAccessItemShareSharePermissions.
        Returns Share level permissions for the user.{ 'read' , 'write' , 'full' or 'none' will be the values}

        :return: The expected_permissions of this AuthAccessAccessItemShareSharePermissions.
        :rtype: str
        """
        return self._expected_permissions

    @expected_permissions.setter
    def expected_permissions(self, expected_permissions):
        """
        Sets the expected_permissions of this AuthAccessAccessItemShareSharePermissions.
        Returns Share level permissions for the user.{ 'read' , 'write' , 'full' or 'none' will be the values}

        :param expected_permissions: The expected_permissions of this AuthAccessAccessItemShareSharePermissions.
        :type: str
        """
        
        self._expected_permissions = expected_permissions

    @property
    def impersonate_guest(self):
        """
        Gets the impersonate_guest of this AuthAccessAccessItemShareSharePermissions.
        Returns whether impersonate guest setting is enabled for the user on the share.

        :return: The impersonate_guest of this AuthAccessAccessItemShareSharePermissions.
        :rtype: bool
        """
        return self._impersonate_guest

    @impersonate_guest.setter
    def impersonate_guest(self, impersonate_guest):
        """
        Sets the impersonate_guest of this AuthAccessAccessItemShareSharePermissions.
        Returns whether impersonate guest setting is enabled for the user on the share.

        :param impersonate_guest: The impersonate_guest of this AuthAccessAccessItemShareSharePermissions.
        :type: bool
        """
        
        self._impersonate_guest = impersonate_guest

    @property
    def impersonate_user(self):
        """
        Gets the impersonate_user of this AuthAccessAccessItemShareSharePermissions.
        Returns whether impersonate user setting is enabled on the share

        :return: The impersonate_user of this AuthAccessAccessItemShareSharePermissions.
        :rtype: bool
        """
        return self._impersonate_user

    @impersonate_user.setter
    def impersonate_user(self, impersonate_user):
        """
        Sets the impersonate_user of this AuthAccessAccessItemShareSharePermissions.
        Returns whether impersonate user setting is enabled on the share

        :param impersonate_user: The impersonate_user of this AuthAccessAccessItemShareSharePermissions.
        :type: bool
        """
        
        self._impersonate_user = impersonate_user

    @property
    def run_as_root(self):
        """
        Gets the run_as_root of this AuthAccessAccessItemShareSharePermissions.
        Returns whether run as root is enabled for the user on the share

        :return: The run_as_root of this AuthAccessAccessItemShareSharePermissions.
        :rtype: bool
        """
        return self._run_as_root

    @run_as_root.setter
    def run_as_root(self, run_as_root):
        """
        Sets the run_as_root of this AuthAccessAccessItemShareSharePermissions.
        Returns whether run as root is enabled for the user on the share

        :param run_as_root: The run_as_root of this AuthAccessAccessItemShareSharePermissions.
        :type: bool
        """
        
        self._run_as_root = run_as_root

    @property
    def share_relevant_aces(self):
        """
        Gets the share_relevant_aces of this AuthAccessAccessItemShareSharePermissions.
        Specifies a list of the relevant Access Control Entries withrespect to the user in the share.

        :return: The share_relevant_aces of this AuthAccessAccessItemShareSharePermissions.
        :rtype: list[AuthAccessAccessItemShareSharePermissionsShareRelevantAce]
        """
        return self._share_relevant_aces

    @share_relevant_aces.setter
    def share_relevant_aces(self, share_relevant_aces):
        """
        Sets the share_relevant_aces of this AuthAccessAccessItemShareSharePermissions.
        Specifies a list of the relevant Access Control Entries withrespect to the user in the share.

        :param share_relevant_aces: The share_relevant_aces of this AuthAccessAccessItemShareSharePermissions.
        :type: list[AuthAccessAccessItemShareSharePermissionsShareRelevantAce]
        """
        
        self._share_relevant_aces = share_relevant_aces

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

