# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class CloudProxyCreateParams(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CloudProxyCreateParams - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'host': 'str',
            'name': 'str',
            'password': 'str',
            'port': 'int',
            'type': 'str',
            'username': 'str'
        }

        self.attribute_map = {
            'host': 'host',
            'name': 'name',
            'password': 'password',
            'port': 'port',
            'type': 'type',
            'username': 'username'
        }

        self._host = None
        self._name = None
        self._password = None
        self._port = None
        self._type = None
        self._username = None

    @property
    def host(self):
        """
        Gets the host of this CloudProxyCreateParams.
        A host name or network address for connecting to this proxy

        :return: The host of this CloudProxyCreateParams.
        :rtype: str
        """
        return self._host

    @host.setter
    def host(self, host):
        """
        Sets the host of this CloudProxyCreateParams.
        A host name or network address for connecting to this proxy

        :param host: The host of this CloudProxyCreateParams.
        :type: str
        """
        
        self._host = host

    @property
    def name(self):
        """
        Gets the name of this CloudProxyCreateParams.
        A unique friendly name for this proxy configuration

        :return: The name of this CloudProxyCreateParams.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this CloudProxyCreateParams.
        A unique friendly name for this proxy configuration

        :param name: The name of this CloudProxyCreateParams.
        :type: str
        """
        
        self._name = name

    @property
    def password(self):
        """
        Gets the password of this CloudProxyCreateParams.
        The password to connect to this proxy if required (write-only)

        :return: The password of this CloudProxyCreateParams.
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """
        Sets the password of this CloudProxyCreateParams.
        The password to connect to this proxy if required (write-only)

        :param password: The password of this CloudProxyCreateParams.
        :type: str
        """
        
        self._password = password

    @property
    def port(self):
        """
        Gets the port of this CloudProxyCreateParams.
        The port used to connect to this proxy

        :return: The port of this CloudProxyCreateParams.
        :rtype: int
        """
        return self._port

    @port.setter
    def port(self, port):
        """
        Sets the port of this CloudProxyCreateParams.
        The port used to connect to this proxy

        :param port: The port of this CloudProxyCreateParams.
        :type: int
        """
        
        self._port = port

    @property
    def type(self):
        """
        Gets the type of this CloudProxyCreateParams.
        The type of connection used to connect to this proxy

        :return: The type of this CloudProxyCreateParams.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this CloudProxyCreateParams.
        The type of connection used to connect to this proxy

        :param type: The type of this CloudProxyCreateParams.
        :type: str
        """
        allowed_values = ["socks_4", "socks_5", "http"]
        if type is not None and type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )

        self._type = type

    @property
    def username(self):
        """
        Gets the username of this CloudProxyCreateParams.
        The username to connect to this proxy if required

        :return: The username of this CloudProxyCreateParams.
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """
        Sets the username of this CloudProxyCreateParams.
        The username to connect to this proxy if required

        :param username: The username of this CloudProxyCreateParams.
        :type: str
        """
        
        self._username = username

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

