# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class CloudSettingsSettings(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CloudSettingsSettings - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'cloud_policy_defaults': 'CloudSettingsSettingsCloudPolicyDefaults',
            'retry_coefficient_archive': 'str',
            'retry_coefficient_cache_invalidation': 'str',
            'retry_coefficient_cloud_garbage_collection': 'str',
            'retry_coefficient_local_garbage_collection': 'str',
            'retry_coefficient_read_ahead': 'str',
            'retry_coefficient_recall': 'str',
            'retry_coefficient_writeback': 'str',
            'sleep_timeout_archive': 'CloudSettingsSettingsSleepTimeoutCloudGarbageCollection',
            'sleep_timeout_cache_invalidation': 'CloudSettingsSettingsSleepTimeoutCloudGarbageCollection',
            'sleep_timeout_cloud_garbage_collection': 'CloudSettingsSettingsSleepTimeoutCloudGarbageCollection',
            'sleep_timeout_local_garbage_collection': 'CloudSettingsSettingsSleepTimeoutCloudGarbageCollection',
            'sleep_timeout_read_ahead': 'CloudSettingsSettingsSleepTimeoutCloudGarbageCollection',
            'sleep_timeout_recall': 'CloudSettingsSettingsSleepTimeoutCloudGarbageCollection',
            'sleep_timeout_writeback': 'CloudSettingsSettingsSleepTimeoutCloudGarbageCollection'
        }

        self.attribute_map = {
            'cloud_policy_defaults': 'cloud_policy_defaults',
            'retry_coefficient_archive': 'retry_coefficient_archive',
            'retry_coefficient_cache_invalidation': 'retry_coefficient_cache_invalidation',
            'retry_coefficient_cloud_garbage_collection': 'retry_coefficient_cloud_garbage_collection',
            'retry_coefficient_local_garbage_collection': 'retry_coefficient_local_garbage_collection',
            'retry_coefficient_read_ahead': 'retry_coefficient_read_ahead',
            'retry_coefficient_recall': 'retry_coefficient_recall',
            'retry_coefficient_writeback': 'retry_coefficient_writeback',
            'sleep_timeout_archive': 'sleep_timeout_archive',
            'sleep_timeout_cache_invalidation': 'sleep_timeout_cache_invalidation',
            'sleep_timeout_cloud_garbage_collection': 'sleep_timeout_cloud_garbage_collection',
            'sleep_timeout_local_garbage_collection': 'sleep_timeout_local_garbage_collection',
            'sleep_timeout_read_ahead': 'sleep_timeout_read_ahead',
            'sleep_timeout_recall': 'sleep_timeout_recall',
            'sleep_timeout_writeback': 'sleep_timeout_writeback'
        }

        self._cloud_policy_defaults = None
        self._retry_coefficient_archive = None
        self._retry_coefficient_cache_invalidation = None
        self._retry_coefficient_cloud_garbage_collection = None
        self._retry_coefficient_local_garbage_collection = None
        self._retry_coefficient_read_ahead = None
        self._retry_coefficient_recall = None
        self._retry_coefficient_writeback = None
        self._sleep_timeout_archive = None
        self._sleep_timeout_cache_invalidation = None
        self._sleep_timeout_cloud_garbage_collection = None
        self._sleep_timeout_local_garbage_collection = None
        self._sleep_timeout_read_ahead = None
        self._sleep_timeout_recall = None
        self._sleep_timeout_writeback = None

    @property
    def cloud_policy_defaults(self):
        """
        Gets the cloud_policy_defaults of this CloudSettingsSettings.
        The default filepool policy values for cloudpools.

        :return: The cloud_policy_defaults of this CloudSettingsSettings.
        :rtype: CloudSettingsSettingsCloudPolicyDefaults
        """
        return self._cloud_policy_defaults

    @cloud_policy_defaults.setter
    def cloud_policy_defaults(self, cloud_policy_defaults):
        """
        Sets the cloud_policy_defaults of this CloudSettingsSettings.
        The default filepool policy values for cloudpools.

        :param cloud_policy_defaults: The cloud_policy_defaults of this CloudSettingsSettings.
        :type: CloudSettingsSettingsCloudPolicyDefaults
        """
        
        self._cloud_policy_defaults = cloud_policy_defaults

    @property
    def retry_coefficient_archive(self):
        """
        Gets the retry_coefficient_archive of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive archive attempts.

        :return: The retry_coefficient_archive of this CloudSettingsSettings.
        :rtype: str
        """
        return self._retry_coefficient_archive

    @retry_coefficient_archive.setter
    def retry_coefficient_archive(self, retry_coefficient_archive):
        """
        Sets the retry_coefficient_archive of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive archive attempts.

        :param retry_coefficient_archive: The retry_coefficient_archive of this CloudSettingsSettings.
        :type: str
        """
        
        self._retry_coefficient_archive = retry_coefficient_archive

    @property
    def retry_coefficient_cache_invalidation(self):
        """
        Gets the retry_coefficient_cache_invalidation of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive cache invalidation attempts.

        :return: The retry_coefficient_cache_invalidation of this CloudSettingsSettings.
        :rtype: str
        """
        return self._retry_coefficient_cache_invalidation

    @retry_coefficient_cache_invalidation.setter
    def retry_coefficient_cache_invalidation(self, retry_coefficient_cache_invalidation):
        """
        Sets the retry_coefficient_cache_invalidation of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive cache invalidation attempts.

        :param retry_coefficient_cache_invalidation: The retry_coefficient_cache_invalidation of this CloudSettingsSettings.
        :type: str
        """
        
        self._retry_coefficient_cache_invalidation = retry_coefficient_cache_invalidation

    @property
    def retry_coefficient_cloud_garbage_collection(self):
        """
        Gets the retry_coefficient_cloud_garbage_collection of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive cloud garbage collection attempts.

        :return: The retry_coefficient_cloud_garbage_collection of this CloudSettingsSettings.
        :rtype: str
        """
        return self._retry_coefficient_cloud_garbage_collection

    @retry_coefficient_cloud_garbage_collection.setter
    def retry_coefficient_cloud_garbage_collection(self, retry_coefficient_cloud_garbage_collection):
        """
        Sets the retry_coefficient_cloud_garbage_collection of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive cloud garbage collection attempts.

        :param retry_coefficient_cloud_garbage_collection: The retry_coefficient_cloud_garbage_collection of this CloudSettingsSettings.
        :type: str
        """
        
        self._retry_coefficient_cloud_garbage_collection = retry_coefficient_cloud_garbage_collection

    @property
    def retry_coefficient_local_garbage_collection(self):
        """
        Gets the retry_coefficient_local_garbage_collection of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive local garbage collection attempts.

        :return: The retry_coefficient_local_garbage_collection of this CloudSettingsSettings.
        :rtype: str
        """
        return self._retry_coefficient_local_garbage_collection

    @retry_coefficient_local_garbage_collection.setter
    def retry_coefficient_local_garbage_collection(self, retry_coefficient_local_garbage_collection):
        """
        Sets the retry_coefficient_local_garbage_collection of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive local garbage collection attempts.

        :param retry_coefficient_local_garbage_collection: The retry_coefficient_local_garbage_collection of this CloudSettingsSettings.
        :type: str
        """
        
        self._retry_coefficient_local_garbage_collection = retry_coefficient_local_garbage_collection

    @property
    def retry_coefficient_read_ahead(self):
        """
        Gets the retry_coefficient_read_ahead of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive read ahead attempts.

        :return: The retry_coefficient_read_ahead of this CloudSettingsSettings.
        :rtype: str
        """
        return self._retry_coefficient_read_ahead

    @retry_coefficient_read_ahead.setter
    def retry_coefficient_read_ahead(self, retry_coefficient_read_ahead):
        """
        Sets the retry_coefficient_read_ahead of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive read ahead attempts.

        :param retry_coefficient_read_ahead: The retry_coefficient_read_ahead of this CloudSettingsSettings.
        :type: str
        """
        
        self._retry_coefficient_read_ahead = retry_coefficient_read_ahead

    @property
    def retry_coefficient_recall(self):
        """
        Gets the retry_coefficient_recall of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive recall attempts.

        :return: The retry_coefficient_recall of this CloudSettingsSettings.
        :rtype: str
        """
        return self._retry_coefficient_recall

    @retry_coefficient_recall.setter
    def retry_coefficient_recall(self, retry_coefficient_recall):
        """
        Sets the retry_coefficient_recall of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive recall attempts.

        :param retry_coefficient_recall: The retry_coefficient_recall of this CloudSettingsSettings.
        :type: str
        """
        
        self._retry_coefficient_recall = retry_coefficient_recall

    @property
    def retry_coefficient_writeback(self):
        """
        Gets the retry_coefficient_writeback of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive writeback attempts.

        :return: The retry_coefficient_writeback of this CloudSettingsSettings.
        :rtype: str
        """
        return self._retry_coefficient_writeback

    @retry_coefficient_writeback.setter
    def retry_coefficient_writeback(self, retry_coefficient_writeback):
        """
        Sets the retry_coefficient_writeback of this CloudSettingsSettings.
        Coefficients in the quadratic function for determining the rest period between successive writeback attempts.

        :param retry_coefficient_writeback: The retry_coefficient_writeback of this CloudSettingsSettings.
        :type: str
        """
        
        self._retry_coefficient_writeback = retry_coefficient_writeback

    @property
    def sleep_timeout_archive(self):
        """
        Gets the sleep_timeout_archive of this CloudSettingsSettings.
        Amount of time to wait between successive file archive operations.

        :return: The sleep_timeout_archive of this CloudSettingsSettings.
        :rtype: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        return self._sleep_timeout_archive

    @sleep_timeout_archive.setter
    def sleep_timeout_archive(self, sleep_timeout_archive):
        """
        Sets the sleep_timeout_archive of this CloudSettingsSettings.
        Amount of time to wait between successive file archive operations.

        :param sleep_timeout_archive: The sleep_timeout_archive of this CloudSettingsSettings.
        :type: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        
        self._sleep_timeout_archive = sleep_timeout_archive

    @property
    def sleep_timeout_cache_invalidation(self):
        """
        Gets the sleep_timeout_cache_invalidation of this CloudSettingsSettings.
        Amount of time to wait between successive file cache_invalidation operations.

        :return: The sleep_timeout_cache_invalidation of this CloudSettingsSettings.
        :rtype: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        return self._sleep_timeout_cache_invalidation

    @sleep_timeout_cache_invalidation.setter
    def sleep_timeout_cache_invalidation(self, sleep_timeout_cache_invalidation):
        """
        Sets the sleep_timeout_cache_invalidation of this CloudSettingsSettings.
        Amount of time to wait between successive file cache_invalidation operations.

        :param sleep_timeout_cache_invalidation: The sleep_timeout_cache_invalidation of this CloudSettingsSettings.
        :type: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        
        self._sleep_timeout_cache_invalidation = sleep_timeout_cache_invalidation

    @property
    def sleep_timeout_cloud_garbage_collection(self):
        """
        Gets the sleep_timeout_cloud_garbage_collection of this CloudSettingsSettings.
        Amount of time to wait between successive file cloud garbage collection operations.

        :return: The sleep_timeout_cloud_garbage_collection of this CloudSettingsSettings.
        :rtype: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        return self._sleep_timeout_cloud_garbage_collection

    @sleep_timeout_cloud_garbage_collection.setter
    def sleep_timeout_cloud_garbage_collection(self, sleep_timeout_cloud_garbage_collection):
        """
        Sets the sleep_timeout_cloud_garbage_collection of this CloudSettingsSettings.
        Amount of time to wait between successive file cloud garbage collection operations.

        :param sleep_timeout_cloud_garbage_collection: The sleep_timeout_cloud_garbage_collection of this CloudSettingsSettings.
        :type: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        
        self._sleep_timeout_cloud_garbage_collection = sleep_timeout_cloud_garbage_collection

    @property
    def sleep_timeout_local_garbage_collection(self):
        """
        Gets the sleep_timeout_local_garbage_collection of this CloudSettingsSettings.
        Amount of time to wait between successive file local garbage collection operations.

        :return: The sleep_timeout_local_garbage_collection of this CloudSettingsSettings.
        :rtype: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        return self._sleep_timeout_local_garbage_collection

    @sleep_timeout_local_garbage_collection.setter
    def sleep_timeout_local_garbage_collection(self, sleep_timeout_local_garbage_collection):
        """
        Sets the sleep_timeout_local_garbage_collection of this CloudSettingsSettings.
        Amount of time to wait between successive file local garbage collection operations.

        :param sleep_timeout_local_garbage_collection: The sleep_timeout_local_garbage_collection of this CloudSettingsSettings.
        :type: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        
        self._sleep_timeout_local_garbage_collection = sleep_timeout_local_garbage_collection

    @property
    def sleep_timeout_read_ahead(self):
        """
        Gets the sleep_timeout_read_ahead of this CloudSettingsSettings.
        Amount of time to wait between successive file read ahead operations.

        :return: The sleep_timeout_read_ahead of this CloudSettingsSettings.
        :rtype: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        return self._sleep_timeout_read_ahead

    @sleep_timeout_read_ahead.setter
    def sleep_timeout_read_ahead(self, sleep_timeout_read_ahead):
        """
        Sets the sleep_timeout_read_ahead of this CloudSettingsSettings.
        Amount of time to wait between successive file read ahead operations.

        :param sleep_timeout_read_ahead: The sleep_timeout_read_ahead of this CloudSettingsSettings.
        :type: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        
        self._sleep_timeout_read_ahead = sleep_timeout_read_ahead

    @property
    def sleep_timeout_recall(self):
        """
        Gets the sleep_timeout_recall of this CloudSettingsSettings.
        Amount of time to wait between successive file recall operations.

        :return: The sleep_timeout_recall of this CloudSettingsSettings.
        :rtype: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        return self._sleep_timeout_recall

    @sleep_timeout_recall.setter
    def sleep_timeout_recall(self, sleep_timeout_recall):
        """
        Sets the sleep_timeout_recall of this CloudSettingsSettings.
        Amount of time to wait between successive file recall operations.

        :param sleep_timeout_recall: The sleep_timeout_recall of this CloudSettingsSettings.
        :type: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        
        self._sleep_timeout_recall = sleep_timeout_recall

    @property
    def sleep_timeout_writeback(self):
        """
        Gets the sleep_timeout_writeback of this CloudSettingsSettings.
        Amount of time to wait between successive file writeback operations.

        :return: The sleep_timeout_writeback of this CloudSettingsSettings.
        :rtype: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        return self._sleep_timeout_writeback

    @sleep_timeout_writeback.setter
    def sleep_timeout_writeback(self, sleep_timeout_writeback):
        """
        Sets the sleep_timeout_writeback of this CloudSettingsSettings.
        Amount of time to wait between successive file writeback operations.

        :param sleep_timeout_writeback: The sleep_timeout_writeback of this CloudSettingsSettings.
        :type: CloudSettingsSettingsSleepTimeoutCloudGarbageCollection
        """
        
        self._sleep_timeout_writeback = sleep_timeout_writeback

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

