# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class CompatibilitiesSsdActiveIdParams(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CompatibilitiesSsdActiveIdParams - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'assess': 'bool',
            'count': 'bool',
            'id_2': 'int'
        }

        self.attribute_map = {
            'assess': 'assess',
            'count': 'count',
            'id_2': 'id_2'
        }

        self._assess = None
        self._count = None
        self._id_2 = None

    @property
    def assess(self):
        """
        Gets the assess of this CompatibilitiesSsdActiveIdParams.
        Do not delete ssd compatibility, only assess if deletion is possible.

        :return: The assess of this CompatibilitiesSsdActiveIdParams.
        :rtype: bool
        """
        return self._assess

    @assess.setter
    def assess(self, assess):
        """
        Sets the assess of this CompatibilitiesSsdActiveIdParams.
        Do not delete ssd compatibility, only assess if deletion is possible.

        :param assess: The assess of this CompatibilitiesSsdActiveIdParams.
        :type: bool
        """
        
        self._assess = assess

    @property
    def count(self):
        """
        Gets the count of this CompatibilitiesSsdActiveIdParams.
        Are we enabling or disabling count

        :return: The count of this CompatibilitiesSsdActiveIdParams.
        :rtype: bool
        """
        return self._count

    @count.setter
    def count(self, count):
        """
        Sets the count of this CompatibilitiesSsdActiveIdParams.
        Are we enabling or disabling count

        :param count: The count of this CompatibilitiesSsdActiveIdParams.
        :type: bool
        """
        
        self._count = count

    @property
    def id_2(self):
        """
        Gets the id_2 of this CompatibilitiesSsdActiveIdParams.
        The optional id of the second ssd compatibility.

        :return: The id_2 of this CompatibilitiesSsdActiveIdParams.
        :rtype: int
        """
        return self._id_2

    @id_2.setter
    def id_2(self, id_2):
        """
        Sets the id_2 of this CompatibilitiesSsdActiveIdParams.
        The optional id of the second ssd compatibility.

        :param id_2: The id_2 of this CompatibilitiesSsdActiveIdParams.
        :type: int
        """
        
        self._id_2 = id_2

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

