# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class DedupeSettingsSettings(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DedupeSettingsSettings - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'assess_paths': 'list[str]',
            'dedupe_schedule': 'str',
            'paths': 'list[str]'
        }

        self.attribute_map = {
            'assess_paths': 'assess_paths',
            'dedupe_schedule': 'dedupe_schedule',
            'paths': 'paths'
        }

        self._assess_paths = None
        self._dedupe_schedule = None
        self._paths = None

    @property
    def assess_paths(self):
        """
        Gets the assess_paths of this DedupeSettingsSettings.
        The paths that will be assessed.

        :return: The assess_paths of this DedupeSettingsSettings.
        :rtype: list[str]
        """
        return self._assess_paths

    @assess_paths.setter
    def assess_paths(self, assess_paths):
        """
        Sets the assess_paths of this DedupeSettingsSettings.
        The paths that will be assessed.

        :param assess_paths: The assess_paths of this DedupeSettingsSettings.
        :type: list[str]
        """
        
        self._assess_paths = assess_paths

    @property
    def dedupe_schedule(self):
        """
        Gets the dedupe_schedule of this DedupeSettingsSettings.
        The schedule for the dedupe job.

        :return: The dedupe_schedule of this DedupeSettingsSettings.
        :rtype: str
        """
        return self._dedupe_schedule

    @dedupe_schedule.setter
    def dedupe_schedule(self, dedupe_schedule):
        """
        Sets the dedupe_schedule of this DedupeSettingsSettings.
        The schedule for the dedupe job.

        :param dedupe_schedule: The dedupe_schedule of this DedupeSettingsSettings.
        :type: str
        """
        
        self._dedupe_schedule = dedupe_schedule

    @property
    def paths(self):
        """
        Gets the paths of this DedupeSettingsSettings.
        The paths that will be deduped.

        :return: The paths of this DedupeSettingsSettings.
        :rtype: list[str]
        """
        return self._paths

    @paths.setter
    def paths(self, paths):
        """
        Sets the paths of this DedupeSettingsSettings.
        The paths that will be deduped.

        :param paths: The paths of this DedupeSettingsSettings.
        :type: list[str]
        """
        
        self._paths = paths

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

