# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class EventEventlistsEventlistItem(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        EventEventlistsEventlistItem - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'event_count': 'int',
            'eventgroup_instance': 'str',
            'events': 'list[EventEventlistsEventlistItemEvent]',
            'id': 'str'
        }

        self.attribute_map = {
            'event_count': 'event_count',
            'eventgroup_instance': 'eventgroup_instance',
            'events': 'events',
            'id': 'id'
        }

        self._event_count = None
        self._eventgroup_instance = None
        self._events = None
        self._id = None

    @property
    def event_count(self):
        """
        Gets the event_count of this EventEventlistsEventlistItem.
        Number of events linked to this eventgroup.

        :return: The event_count of this EventEventlistsEventlistItem.
        :rtype: int
        """
        return self._event_count

    @event_count.setter
    def event_count(self, event_count):
        """
        Sets the event_count of this EventEventlistsEventlistItem.
        Number of events linked to this eventgroup.

        :param event_count: The event_count of this EventEventlistsEventlistItem.
        :type: int
        """
        
        self._event_count = event_count

    @property
    def eventgroup_instance(self):
        """
        Gets the eventgroup_instance of this EventEventlistsEventlistItem.
        Unique identifier of eventgroup instance.

        :return: The eventgroup_instance of this EventEventlistsEventlistItem.
        :rtype: str
        """
        return self._eventgroup_instance

    @eventgroup_instance.setter
    def eventgroup_instance(self, eventgroup_instance):
        """
        Sets the eventgroup_instance of this EventEventlistsEventlistItem.
        Unique identifier of eventgroup instance.

        :param eventgroup_instance: The eventgroup_instance of this EventEventlistsEventlistItem.
        :type: str
        """
        
        self._eventgroup_instance = eventgroup_instance

    @property
    def events(self):
        """
        Gets the events of this EventEventlistsEventlistItem.
        list of all events linked to this eventgroup in chronological order.

        :return: The events of this EventEventlistsEventlistItem.
        :rtype: list[EventEventlistsEventlistItemEvent]
        """
        return self._events

    @events.setter
    def events(self, events):
        """
        Sets the events of this EventEventlistsEventlistItem.
        list of all events linked to this eventgroup in chronological order.

        :param events: The events of this EventEventlistsEventlistItem.
        :type: list[EventEventlistsEventlistItemEvent]
        """
        
        self._events = events

    @property
    def id(self):
        """
        Gets the id of this EventEventlistsEventlistItem.
        Same as eventgroup_instance.

        :return: The id of this EventEventlistsEventlistItem.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this EventEventlistsEventlistItem.
        Same as eventgroup_instance.

        :param id: The id of this EventEventlistsEventlistItem.
        :type: str
        """
        
        self._id = id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

