# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class HdfsRangerPluginSettingsSettings(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        HdfsRangerPluginSettingsSettings - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'enabled': 'bool',
            'policy_manager_url': 'str',
            'repository_name': 'str'
        }

        self.attribute_map = {
            'enabled': 'enabled',
            'policy_manager_url': 'policy_manager_url',
            'repository_name': 'repository_name'
        }

        self._enabled = None
        self._policy_manager_url = None
        self._repository_name = None

    @property
    def enabled(self):
        """
        Gets the enabled of this HdfsRangerPluginSettingsSettings.
        Enable or disable the HDFS ranger plugin

        :return: The enabled of this HdfsRangerPluginSettingsSettings.
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """
        Sets the enabled of this HdfsRangerPluginSettingsSettings.
        Enable or disable the HDFS ranger plugin

        :param enabled: The enabled of this HdfsRangerPluginSettingsSettings.
        :type: bool
        """
        
        self._enabled = enabled

    @property
    def policy_manager_url(self):
        """
        Gets the policy_manager_url of this HdfsRangerPluginSettingsSettings.
        The scheme, hostname, and port of the Apache Ranger server (e.g. http://ranger.com:6080)

        :return: The policy_manager_url of this HdfsRangerPluginSettingsSettings.
        :rtype: str
        """
        return self._policy_manager_url

    @policy_manager_url.setter
    def policy_manager_url(self, policy_manager_url):
        """
        Sets the policy_manager_url of this HdfsRangerPluginSettingsSettings.
        The scheme, hostname, and port of the Apache Ranger server (e.g. http://ranger.com:6080)

        :param policy_manager_url: The policy_manager_url of this HdfsRangerPluginSettingsSettings.
        :type: str
        """
        
        self._policy_manager_url = policy_manager_url

    @property
    def repository_name(self):
        """
        Gets the repository_name of this HdfsRangerPluginSettingsSettings.
        The HDFS repository name that is registered with Apache Ranger server

        :return: The repository_name of this HdfsRangerPluginSettingsSettings.
        :rtype: str
        """
        return self._repository_name

    @repository_name.setter
    def repository_name(self, repository_name):
        """
        Sets the repository_name of this HdfsRangerPluginSettingsSettings.
        The HDFS repository name that is registered with Apache Ranger server

        :param repository_name: The repository_name of this HdfsRangerPluginSettingsSettings.
        :type: str
        """
        
        self._repository_name = repository_name

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

