# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class NodeStatusNode(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        NodeStatusNode - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'batterystatus': 'NodeStatusNodeBatterystatus',
            'capacity': 'list[NodeStatusNodeCapacityItem]',
            'cpu': 'NodeStatusNodeCpu',
            'id': 'int',
            'lnn': 'int',
            'nvram': 'NodeStatusNodeNvram',
            'powersupplies': 'NodeStatusNodePowersupplies',
            'release': 'str',
            'uptime': 'int',
            'version': 'str'
        }

        self.attribute_map = {
            'batterystatus': 'batterystatus',
            'capacity': 'capacity',
            'cpu': 'cpu',
            'id': 'id',
            'lnn': 'lnn',
            'nvram': 'nvram',
            'powersupplies': 'powersupplies',
            'release': 'release',
            'uptime': 'uptime',
            'version': 'version'
        }

        self._batterystatus = None
        self._capacity = None
        self._cpu = None
        self._id = None
        self._lnn = None
        self._nvram = None
        self._powersupplies = None
        self._release = None
        self._uptime = None
        self._version = None

    @property
    def batterystatus(self):
        """
        Gets the batterystatus of this NodeStatusNode.
        Battery status information.

        :return: The batterystatus of this NodeStatusNode.
        :rtype: NodeStatusNodeBatterystatus
        """
        return self._batterystatus

    @batterystatus.setter
    def batterystatus(self, batterystatus):
        """
        Sets the batterystatus of this NodeStatusNode.
        Battery status information.

        :param batterystatus: The batterystatus of this NodeStatusNode.
        :type: NodeStatusNodeBatterystatus
        """
        
        self._batterystatus = batterystatus

    @property
    def capacity(self):
        """
        Gets the capacity of this NodeStatusNode.
        Storage capacity of this node.

        :return: The capacity of this NodeStatusNode.
        :rtype: list[NodeStatusNodeCapacityItem]
        """
        return self._capacity

    @capacity.setter
    def capacity(self, capacity):
        """
        Sets the capacity of this NodeStatusNode.
        Storage capacity of this node.

        :param capacity: The capacity of this NodeStatusNode.
        :type: list[NodeStatusNodeCapacityItem]
        """
        
        self._capacity = capacity

    @property
    def cpu(self):
        """
        Gets the cpu of this NodeStatusNode.
        CPU status information for this node.

        :return: The cpu of this NodeStatusNode.
        :rtype: NodeStatusNodeCpu
        """
        return self._cpu

    @cpu.setter
    def cpu(self, cpu):
        """
        Sets the cpu of this NodeStatusNode.
        CPU status information for this node.

        :param cpu: The cpu of this NodeStatusNode.
        :type: NodeStatusNodeCpu
        """
        
        self._cpu = cpu

    @property
    def id(self):
        """
        Gets the id of this NodeStatusNode.
        Node ID (Device Number) of this node.

        :return: The id of this NodeStatusNode.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this NodeStatusNode.
        Node ID (Device Number) of this node.

        :param id: The id of this NodeStatusNode.
        :type: int
        """
        
        self._id = id

    @property
    def lnn(self):
        """
        Gets the lnn of this NodeStatusNode.
        Logical Node Number (LNN) of this node.

        :return: The lnn of this NodeStatusNode.
        :rtype: int
        """
        return self._lnn

    @lnn.setter
    def lnn(self, lnn):
        """
        Sets the lnn of this NodeStatusNode.
        Logical Node Number (LNN) of this node.

        :param lnn: The lnn of this NodeStatusNode.
        :type: int
        """
        
        self._lnn = lnn

    @property
    def nvram(self):
        """
        Gets the nvram of this NodeStatusNode.
        Node NVRAM information.

        :return: The nvram of this NodeStatusNode.
        :rtype: NodeStatusNodeNvram
        """
        return self._nvram

    @nvram.setter
    def nvram(self, nvram):
        """
        Sets the nvram of this NodeStatusNode.
        Node NVRAM information.

        :param nvram: The nvram of this NodeStatusNode.
        :type: NodeStatusNodeNvram
        """
        
        self._nvram = nvram

    @property
    def powersupplies(self):
        """
        Gets the powersupplies of this NodeStatusNode.
        Information about this node's power supplies.

        :return: The powersupplies of this NodeStatusNode.
        :rtype: NodeStatusNodePowersupplies
        """
        return self._powersupplies

    @powersupplies.setter
    def powersupplies(self, powersupplies):
        """
        Sets the powersupplies of this NodeStatusNode.
        Information about this node's power supplies.

        :param powersupplies: The powersupplies of this NodeStatusNode.
        :type: NodeStatusNodePowersupplies
        """
        
        self._powersupplies = powersupplies

    @property
    def release(self):
        """
        Gets the release of this NodeStatusNode.
        OneFS release.

        :return: The release of this NodeStatusNode.
        :rtype: str
        """
        return self._release

    @release.setter
    def release(self, release):
        """
        Sets the release of this NodeStatusNode.
        OneFS release.

        :param release: The release of this NodeStatusNode.
        :type: str
        """
        
        self._release = release

    @property
    def uptime(self):
        """
        Gets the uptime of this NodeStatusNode.
        Seconds this node has been online.

        :return: The uptime of this NodeStatusNode.
        :rtype: int
        """
        return self._uptime

    @uptime.setter
    def uptime(self, uptime):
        """
        Sets the uptime of this NodeStatusNode.
        Seconds this node has been online.

        :param uptime: The uptime of this NodeStatusNode.
        :type: int
        """
        
        self._uptime = uptime

    @property
    def version(self):
        """
        Gets the version of this NodeStatusNode.
        OneFS version.

        :return: The version of this NodeStatusNode.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this NodeStatusNode.
        OneFS version.

        :param version: The version of this NodeStatusNode.
        :type: str
        """
        
        self._version = version

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

