# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class NodeStatusNodeNvramBattery(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        NodeStatusNodeNvramBattery - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'color': 'str',
            'id': 'int',
            'status': 'str',
            'voltage': 'str'
        }

        self.attribute_map = {
            'color': 'color',
            'id': 'id',
            'status': 'status',
            'voltage': 'voltage'
        }

        self._color = None
        self._id = None
        self._status = None
        self._voltage = None

    @property
    def color(self):
        """
        Gets the color of this NodeStatusNodeNvramBattery.
        The current status color of the NVRAM battery.

        :return: The color of this NodeStatusNodeNvramBattery.
        :rtype: str
        """
        return self._color

    @color.setter
    def color(self, color):
        """
        Sets the color of this NodeStatusNodeNvramBattery.
        The current status color of the NVRAM battery.

        :param color: The color of this NodeStatusNodeNvramBattery.
        :type: str
        """
        
        self._color = color

    @property
    def id(self):
        """
        Gets the id of this NodeStatusNodeNvramBattery.
        Identifying index for the NVRAM battery.

        :return: The id of this NodeStatusNodeNvramBattery.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this NodeStatusNodeNvramBattery.
        Identifying index for the NVRAM battery.

        :param id: The id of this NodeStatusNodeNvramBattery.
        :type: int
        """
        
        self._id = id

    @property
    def status(self):
        """
        Gets the status of this NodeStatusNodeNvramBattery.
        The current status message of the NVRAM battery.

        :return: The status of this NodeStatusNodeNvramBattery.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this NodeStatusNodeNvramBattery.
        The current status message of the NVRAM battery.

        :param status: The status of this NodeStatusNodeNvramBattery.
        :type: str
        """
        
        self._status = status

    @property
    def voltage(self):
        """
        Gets the voltage of this NodeStatusNodeNvramBattery.
        The current voltage of the NVRAM battery.

        :return: The voltage of this NodeStatusNodeNvramBattery.
        :rtype: str
        """
        return self._voltage

    @voltage.setter
    def voltage(self, voltage):
        """
        Sets the voltage of this NodeStatusNodeNvramBattery.
        The current voltage of the NVRAM battery.

        :param voltage: The voltage of this NodeStatusNodeNvramBattery.
        :type: str
        """
        
        self._voltage = voltage

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

