# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class ProvidersKrb5IdParamsKeytabEntry(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ProvidersKrb5IdParamsKeytabEntry - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'encryption': 'list[str]',
            'kvno': 'int',
            'spn': 'str',
            'timestamp': 'int'
        }

        self.attribute_map = {
            'encryption': 'encryption',
            'kvno': 'kvno',
            'spn': 'spn',
            'timestamp': 'timestamp'
        }

        self._encryption = None
        self._kvno = None
        self._spn = None
        self._timestamp = None

    @property
    def encryption(self):
        """
        Gets the encryption of this ProvidersKrb5IdParamsKeytabEntry.
        Specifies the encryption types.

        :return: The encryption of this ProvidersKrb5IdParamsKeytabEntry.
        :rtype: list[str]
        """
        return self._encryption

    @encryption.setter
    def encryption(self, encryption):
        """
        Sets the encryption of this ProvidersKrb5IdParamsKeytabEntry.
        Specifies the encryption types.

        :param encryption: The encryption of this ProvidersKrb5IdParamsKeytabEntry.
        :type: list[str]
        """
        
        self._encryption = encryption

    @property
    def kvno(self):
        """
        Gets the kvno of this ProvidersKrb5IdParamsKeytabEntry.
        Specifies the version number of the SPN key.

        :return: The kvno of this ProvidersKrb5IdParamsKeytabEntry.
        :rtype: int
        """
        return self._kvno

    @kvno.setter
    def kvno(self, kvno):
        """
        Sets the kvno of this ProvidersKrb5IdParamsKeytabEntry.
        Specifies the version number of the SPN key.

        :param kvno: The kvno of this ProvidersKrb5IdParamsKeytabEntry.
        :type: int
        """
        
        self._kvno = kvno

    @property
    def spn(self):
        """
        Gets the spn of this ProvidersKrb5IdParamsKeytabEntry.
        Specifies the Service Principal Name (SPN).

        :return: The spn of this ProvidersKrb5IdParamsKeytabEntry.
        :rtype: str
        """
        return self._spn

    @spn.setter
    def spn(self, spn):
        """
        Sets the spn of this ProvidersKrb5IdParamsKeytabEntry.
        Specifies the Service Principal Name (SPN).

        :param spn: The spn of this ProvidersKrb5IdParamsKeytabEntry.
        :type: str
        """
        
        self._spn = spn

    @property
    def timestamp(self):
        """
        Gets the timestamp of this ProvidersKrb5IdParamsKeytabEntry.
        Specifies the time the SPN key was created.

        :return: The timestamp of this ProvidersKrb5IdParamsKeytabEntry.
        :rtype: int
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """
        Sets the timestamp of this ProvidersKrb5IdParamsKeytabEntry.
        Specifies the time the SPN key was created.

        :param timestamp: The timestamp of this ProvidersKrb5IdParamsKeytabEntry.
        :type: int
        """
        
        self._timestamp = timestamp

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

